package com.ims.eval.service.custom;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ims.eval.config.ImaConfig;
import com.ims.eval.entity.custom.DoAction;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * <p>
 * 菜单 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-12
 */
@Service
@Slf4j
public class MenuOperationService {

	@Autowired
	private RestTemplate restTemplate;

	@Autowired
	private ImaConfig imaConfig;

	/**
	 * 获取权限菜单
	 * @param parentId
	 * @return
	 */
	public JSONArray menuList(String parentId, HttpServletRequest request){
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("Blade-Auth", request.getHeader("Blade-Auth"));
		headers.add("code", request.getHeader("code"));


		HttpEntity<Map> param = new HttpEntity<>(null, headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getGatewayUrl()+"ims-ext/sys/sysMenu/menuList?parentId={1}", HttpMethod.POST,param,String.class,parentId);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if(200== responseEntity2.getStatusCodeValue()){
			return JSON.parseArray(responseEntity2.getBody());
		}
		return null;
	}



	/**
	 * 获取用户权限
	 * @return
	 */
	public JSONObject getPrivilegesOfCurrentUserAll(HttpServletRequest request){
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("Blade-Auth", request.getHeader("Blade-Auth"));
		headers.add("code", request.getHeader("code"));


		HttpEntity<Map> param = new HttpEntity<>(null, headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getGatewayUrl()+"ims-ext/sys/sysRole/getPrivilegesOfCurrentUserAll", HttpMethod.POST,param,String.class);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if(200== responseEntity2.getStatusCodeValue()){
			return JSON.parseObject(responseEntity2.getBody());
		}
		return null;
	}


}
